network/pgpool-II: Added (Connection pooler for PostgreSQL).

Signed-off-by: David Spencer <idlemoor@slackbuilds.org>
This commit is contained in:
Dejan Strbac 2018-06-11 00:29:18 +01:00 committed by David Spencer
parent 4240a45e19
commit b24ef18a50
6 changed files with 275 additions and 0 deletions

12
network/pgpool-II/README Normal file
View File

@ -0,0 +1,12 @@
Pgpool-II is a middleware that works between PostgreSQL servers and a
PostgreSQL database client. It has support for:
- Connection Pooling
- SQL Level Replication
- Load Balancing
- Limiting Exceeding Connections
Docs are available at: http://www.pgpool.net/docs/latest/en/html/
Note that this SlackBuild comes without a default configuration. Sample config
files will be dropped in /etc/pgpool.conf.sample-*

View File

@ -0,0 +1,26 @@
config() {
NEW="$1"
OLD="$(dirname $NEW)/$(basename $NEW .new)"
# If there's no config file by that name, mv it over:
if [ ! -r $OLD ]; then
mv $NEW $OLD
elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
# toss the redundant copy
rm $NEW
fi
# Otherwise, we leave the .new copy for the admin to consider...
}
preserve_perms() {
NEW="$1"
OLD="$(dirname $NEW)/$(basename $NEW .new)"
if [ -e $OLD ]; then
cp -a $OLD ${NEW}.incoming
cat $NEW > ${NEW}.incoming
mv ${NEW}.incoming $NEW
fi
config $NEW
}
preserve_perms etc/rc.d/rc.pgpool.new

View File

@ -0,0 +1,101 @@
#!/bin/sh
# Slackware build script for pgpool-II
# Copyright 2018, Dejan Strbac <me@dejanstrbac.com>
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
PRGNAM=pgpool-II
VERSION=${VERSION:-3.7.3}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
if [ -z "$ARCH" ]; then
case "$( uname -m )" in
i?86) ARCH=i586 ;;
arm*) ARCH=arm ;;
*) ARCH=$( uname -m ) ;;
esac
fi
CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
if [ "$ARCH" = "i586" ]; then
SLKCFLAGS="-O2 -march=i586 -mtune=i686"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "i686" ]; then
SLKCFLAGS="-O2 -march=i686 -mtune=i686"
LIBDIRSUFFIX=""
elif [ "$ARCH" = "x86_64" ]; then
SLKCFLAGS="-O2 -fPIC"
LIBDIRSUFFIX="64"
else
SLKCFLAGS="-O2"
LIBDIRSUFFIX=""
fi
set -e
rm -rf $PKG
mkdir -p $TMP $PKG $OUTPUT
cd $TMP
rm -rf $PRGNAM-$VERSION
tar xvf $CWD/$PRGNAM-$VERSION.tar.gz
cd $PRGNAM-$VERSION
chown -R root:root .
find -L . \
\( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
-o -perm 511 \) -exec chmod 755 {} \; -o \
\( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
-o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
CFLAGS="$SLKCFLAGS" \
./configure \
--prefix=/usr \
--libdir=/usr/lib${LIBDIRSUFFIX} \
--sysconfdir=/etc \
--localstatedir=/var \
--mandir=/usr/man \
--docdir=/usr/doc/$PRGNAM-$VERSION \
--build=$ARCH-slackware-linux
make
make install DESTDIR=$PKG
find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
| cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
mkdir -p $PKG/etc/rc.d
cp $CWD/rc.pgpool $PKG/etc/rc.d/rc.pgpool.new
chmod 0755 $PKG/etc/rc.d/rc.pgpool.new
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a AUTHORS COPYING ChangeLog INSTALL NEWS README TODO doc/ src/sql/ $PKG/usr/doc/$PRGNAM-$VERSION
cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
mkdir -p $PKG/install
cat $CWD/slack-desc > $PKG/install/slack-desc
cat $CWD/doinst.sh > $PKG/install/doinst.sh
cd $PKG
/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}

View File

@ -0,0 +1,10 @@
PRGNAM="pgpool-II"
VERSION="3.7.3"
HOMEPAGE="http://www.pgpool.net"
DOWNLOAD="http://www.pgpool.net/download.php?f=pgpool-II-3.7.3.tar.gz"
MD5SUM="622aca1698b29f735042da52a374afed"
DOWNLOAD_x86_64=""
MD5SUM_x86_64=""
REQUIRES="postgresql"
MAINTAINER="Dejan Strbac"
EMAIL="me@dejanstrbac.com"

107
network/pgpool-II/rc.pgpool Normal file
View File

@ -0,0 +1,107 @@
#!/bin/bash
# Slackware build script for pgpool-II
# Copyright 2018, Dejan Strbac <me@dejanstrbac.com>
# All rights reserved.
#
# Redistribution and use of this script, with or without modification, is
# permitted provided that the following conditions are met:
#
# 1. Redistributions of this script must retain the above copyright
# notice, this list of conditions and the following disclaimer.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ''AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
LOGFILE=/var/log/postgresql
PGPOOL=/usr/bin/pgpool
PIDPATH=/var/run/pgpool
PIDFILE=$PIDPATH/pgpool.pid
[ ! -d $PIDPATH ] && mkdir $PIDPATH
case "$1" in
"start")
echo "Starting pgpool-II"
if [ $(pgrep -f $PGPOOL) ]; then
echo "pgpool daemon already running"
if [ ! -f $PIDFILE ]; then
echo "Warning: Missing pid file $PIDFILE"
fi
exit 1
else
$PGPOOL
exit 0
fi
;;
"stop")
echo "Shutting down pgpool-II..."
$PGPOOL stop
;;
"force-stop")
echo "Shutting down pgpool-II (fast)..."
$PGPOOL -m fast stop
;;
"restart")
echo "Restarting pgpool-II..."
if [ $(pgrep -f $PGPOOL) ]; then
$PGPOOL stop; $PGPOOL
exit 1
else
$PGPOOL
exit 0
fi
;;
"force-restart")
echo "Restarting pgpool-II (fast)..."
if [ $(pgrep -f $PGPOOL) ]; then
$PGPOOL -m fast stop; $PGPOOL
exit 1
else
$PGPOOL
exit 0
fi
;;
"reload")
echo "Reloading configuration for pgpool-II..."
$PGPOOL reload
;;
"status")
if [ $(pgrep -f $PGPOOL) ]; then
echo "pgpool-II is running"
if [ ! -f $PIDFILE ]; then
echo "Warning: Missing pid file $PIDFILE"
fi
exit 0
else
echo "pgpool-II is stopped"
if [ ! -f $PIDFILE ]; then
echo "Detected stale pid file $PIDFILE"
fi
exit 0
fi
;;
*)
echo "Usage: $0 {start|stop|force-stop|status|restart|force-restart|reload}"
exit 1
;;
esac

View File

@ -0,0 +1,19 @@
# HOW TO EDIT THIS FILE:
# The "handy ruler" below makes it easier to edit a package description.
# Line up the first '|' above the ':' following the base package name, and
# the '|' on the right side marks the last column you can put a character in.
# You must make exactly 11 lines for the formatting to be correct. It's also
# customary to leave one space after the ':' except on otherwise blank lines.
|-----handy-ruler------------------------------------------------------|
pgpool-II: pgpool-II (Connection pooler for PostgreSQL)
pgpool-II:
pgpool-II: pgpool-II is a middleware that works between PostgreSQL servers and a
pgpool-II: PostgreSQL database client. It is licensed under BSD license. It
pgpool-II: provides the following features: Connection Pooling, Replication,
pgpool-II: Load Balance, Limiting Exceeding Connections and Parallel Query.
pgpool-II:
pgpool-II:
pgpool-II:
pgpool-II: http://www.pgpool.net
pgpool-II: